   PROGRAM



   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFILE.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE

   MAP
     MODULE('Windows API')
SystemParametersInfo PROCEDURE (LONG uAction, LONG uParam, *? lpvParam, LONG fuWinIni),LONG,RAW,PROC,PASCAL,DLL(TRUE),NAME('SystemParametersInfoA')
     END
     MODULE('RTFNOTEPAD_BC.CLW')
DctInit     PROCEDURE                                      ! Initializes the dictionary definition module
DctKill     PROCEDURE                                      ! Kills the dictionary definition module
     END
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('RTFNOTEPAD001.CLW')
Main                   PROCEDURE   !
     END
   END

SilentRunning        BYTE(0)                               ! Set true when application is running in 'silent mode'

!region File Declaration
Customers            FILE,DRIVER('TOPSPEED'),RECLAIM,PRE(CUS),CREATE,BINDABLE,THREAD !                    
SysIDKEY                 KEY(CUS:SysID),NOCASE,OPT,PRIMARY !                    
NameKEY                  KEY(CUS:LastName,CUS:FirstName),DUP,NOCASE,OPT !                    
Record                   RECORD,PRE()
SysID                       LONG                           !                    
FirstName                   STRING(40)                     !                    
LastName                    STRING(40)                     !                    
Address1                    STRING(40)                     !                    
Address2                    STRING(40)                     !                    
City                        STRING(40)                     !                    
State                       STRING(2)                      !                    
Zip                         STRING(20)                     !                    
PrintInvoice                BYTE                           !True or False flag for generating a hardcopy invoice
                         END
                     END                       

Letters              FILE,DRIVER('TOPSPEED'),PRE(LET),CREATE,BINDABLE,THREAD !                    
SysIDKEY                 KEY(LET:SysID),NOCASE,OPT,PRIMARY !                    
NameKEY                  KEY(LET:LetterName),DUP,NOCASE,OPT !                    
Letter                      MEMO(8192)                     !                    
Record                   RECORD,PRE()
SysID                       LONG                           !                    
LetterName                  STRING(40)                     !                    
                         END
                     END                       

TLetters             FILE,DRIVER('TOPSPEED'),NAME('TLetters.tps'),PRE(TLT),CREATE,BINDABLE,THREAD !                    
SysIDKEY                 KEY(TLT:SysID),NOCASE,OPT,PRIMARY !                    
NameKEY                  KEY(TLT:LetterName),DUP,NOCASE,OPT !                    
Letter                      MEMO(8192)                     !                    
Record                   RECORD,PRE()
SysID                       LONG                           !                    
LetterName                  STRING(40)                     !                    
                         END
                     END                       

!endregion

Access:Customers     &FileManager,THREAD                   ! FileManager for Customers
Relate:Customers     &RelationManager,THREAD               ! RelationManager for Customers
Access:Letters       &FileManager,THREAD                   ! FileManager for Letters
Relate:Letters       &RelationManager,THREAD               ! RelationManager for Letters
Access:TLetters      &FileManager,THREAD                   ! FileManager for TLetters
Relate:TLetters      &RelationManager,THREAD               ! RelationManager for TLetters

GlobalErrorStatus    ErrorStatusClass,THREAD
GlobalErrors         ErrorClass                            ! Global error manager
INIMgr               INIClass                              ! Global non-volatile storage manager
GlobalRequest        BYTE(0),THREAD                        ! Set when a browse calls a form, to let it know action to perform
GlobalResponse       BYTE(0),THREAD                        ! Set to the response from the form
VCRRequest           LONG(0),THREAD                        ! Set to the request from the VCR buttons

Dictionary           CLASS,THREAD
Construct              PROCEDURE
Destruct               PROCEDURE
                     END

lCurrentFDSetting    LONG                                  ! Used by window frame dragging
lAdjFDSetting        LONG                                  ! ditto

  CODE
  GlobalErrors.Init(GlobalErrorStatus)
  INIMgr.Init('.\rtfnotepad.INI', NVD_INI)                 ! Configure INIManager to use INI file
  DctInit
  SYSTEM{PROP:Icon} = 'QUILL.ICO'
  SystemParametersInfo (38, 0, lCurrentFDSetting, 0)       ! Configure frame dragging
  IF lCurrentFDSetting = 1
    SystemParametersInfo (37, 0, lAdjFDSetting, 3)
  END
  Main
  INIMgr.Update
  IF lCurrentFDSetting = 1
    SystemParametersInfo (37, 1, lAdjFDSetting, 3)
  END
  INIMgr.Kill                                              ! Destroy INI manager


Dictionary.Construct PROCEDURE

  CODE
  IF THREAD()<>1
     DctInit()
  END


Dictionary.Destruct PROCEDURE

  CODE
  DctKill()

