  MEMBER('rtfnotepad.clw')

  INCLUDE('ABFILE.INC'),ONCE

  MAP
rtfnotepad_BC0:DctInit    PROCEDURE
rtfnotepad_BC0:DctKill    PROCEDURE
rtfnotepad_BC0:FilesInit  PROCEDURE
  END

Hide:Access:Customers CLASS(FileManager),TYPE              ! FileManager for Customers
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:Customers CLASS(RelationManager),TYPE          ! RelationManager for Customers
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:Letters  CLASS(FileManager),TYPE               ! FileManager for Letters
BindFields             PROCEDURE(),DERIVED
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:Letters  CLASS(RelationManager),TYPE           ! RelationManager for Letters
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:TLetters CLASS(FileManager),TYPE               ! FileManager for TLetters
BindFields             PROCEDURE(),DERIVED
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:TLetters CLASS(RelationManager),TYPE           ! RelationManager for TLetters
Init                   PROCEDURE
Kill                   PROCEDURE(),DERIVED
                     END


_Hide:Access:Customers &Hide:Access:Customers,AUTO,THREAD
_Hide:Relate:Customers &Hide:Relate:Customers,AUTO,THREAD
_Hide:Access:Letters &Hide:Access:Letters,AUTO,THREAD
_Hide:Relate:Letters &Hide:Relate:Letters,AUTO,THREAD
_Hide:Access:TLetters &Hide:Access:TLetters,AUTO,THREAD
_Hide:Relate:TLetters &Hide:Relate:TLetters,AUTO,THREAD


rtfnotepad_BC0:DctInit PROCEDURE
  CODE
  _Hide:Access:Customers &= NEW(Hide:Access:Customers)
  _Hide:Relate:Customers &= NEW(Hide:Relate:Customers)
  _Hide:Access:Letters &= NEW(Hide:Access:Letters)
  _Hide:Relate:Letters &= NEW(Hide:Relate:Letters)
  _Hide:Access:TLetters &= NEW(Hide:Access:TLetters)
  _Hide:Relate:TLetters &= NEW(Hide:Relate:TLetters)
  Relate:Customers &= _Hide:Relate:Customers
  Relate:Letters &= _Hide:Relate:Letters
  Relate:TLetters &= _Hide:Relate:TLetters


rtfnotepad_BC0:FilesInit PROCEDURE
  CODE
  _Hide:Relate:Customers.Init
  _Hide:Relate:Letters.Init
  _Hide:Relate:TLetters.Init


rtfnotepad_BC0:DctKill PROCEDURE
  CODE
  _Hide:Relate:Customers.Kill
  DISPOSE(_Hide:Relate:Customers)
  _Hide:Relate:Letters.Kill
  DISPOSE(_Hide:Relate:Letters)
  _Hide:Relate:TLetters.Kill
  DISPOSE(_Hide:Relate:TLetters)


Hide:Relate:Customers.Init PROCEDURE
  CODE
  _Hide:Access:Customers.Init
  SELF.Init(Access:Customers,1)


Hide:Access:Customers.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= CUS:Record
  SELF.FileNameValue = 'Customers'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Customers
  PARENT.Init
  Access:Customers &= SELF
  SELF.LazyOpen = False


Hide:Access:Customers.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Customers &= NULL                                 ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Customers.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Customers,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(CUS:SysIDKEY,'CUS:SysIDKEY',1)
    SELF.AddKey(CUS:NameKEY,'CUS:NameKEY',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:Customers.Kill PROCEDURE

  CODE
  _Hide:Access:Customers.Kill                              ! Kill the file manager
  PARENT.Kill
  Relate:Customers &= NULL                                 ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Customers)                          ! destroy the file manager


Hide:Relate:Letters.Init PROCEDURE
  CODE
  _Hide:Access:Letters.Init
  SELF.Init(Access:Letters,1)


Hide:Access:Letters.BindFields PROCEDURE

  CODE
  PARENT.BindFields
  BIND('LET:Letter',LET:Letter)                            ! Bind memo field


Hide:Access:Letters.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= LET:Record
  SELF.FileNameValue = 'Letters'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Letters
  PARENT.Init
  Access:Letters &= SELF
  SELF.LazyOpen = False


Hide:Access:Letters.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Letters &= NULL                                   ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Letters.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Letters,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(LET:SysIDKEY,'LET:SysIDKEY',1)
    SELF.AddKey(LET:NameKEY,'LET:NameKEY',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:Letters.Kill PROCEDURE

  CODE
  _Hide:Access:Letters.Kill                                ! Kill the file manager
  PARENT.Kill
  Relate:Letters &= NULL                                   ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Letters)                            ! destroy the file manager


Hide:Relate:TLetters.Init PROCEDURE
  CODE
  _Hide:Access:TLetters.Init
  SELF.Init(Access:TLetters,1)


Hide:Access:TLetters.BindFields PROCEDURE

  CODE
  PARENT.BindFields
  BIND('TLT:Letter',TLT:Letter)                            ! Bind memo field


Hide:Access:TLetters.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= TLT:Record
  SELF.FileNameValue = 'TLetters'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= TLetters
  PARENT.Init
  Access:TLetters &= SELF
  SELF.LazyOpen = False


Hide:Access:TLetters.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:TLetters &= NULL                                  ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:TLetters.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(TLetters,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(TLT:SysIDKEY,'TLT:SysIDKEY',1)
    SELF.AddKey(TLT:NameKEY,'TLT:NameKEY',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:TLetters.Kill PROCEDURE

  CODE
  _Hide:Access:TLetters.Kill                               ! Kill the file manager
  PARENT.Kill
  Relate:TLetters &= NULL                                  ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:TLetters)                           ! destroy the file manager

